(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("babel-runtime/core-js/promise"), require("child_process"), require("find-node-modules"), require("findup-sync"), require("fs"), require("path"));
	else if(typeof define === 'function' && define.amd)
		define(["babel-runtime/core-js/promise", "child_process", "find-node-modules", "findup-sync", "fs", "path"], factory);
	else if(typeof exports === 'object')
		exports["SkypagerUtil"] = factory(require("babel-runtime/core-js/promise"), require("child_process"), require("find-node-modules"), require("findup-sync"), require("fs"), require("path"));
	else
		root["SkypagerUtil"] = factory(root["babel-runtime/core-js/promise"], root["child_process"], root["find-node-modules"], root["findup-sync"], root["fs"], root["path"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_15__, __WEBPACK_EXTERNAL_MODULE_37__, __WEBPACK_EXTERNAL_MODULE_38__, __WEBPACK_EXTERNAL_MODULE_39__, __WEBPACK_EXTERNAL_MODULE_17__, __WEBPACK_EXTERNAL_MODULE_32__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.l = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };

/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};

/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};

/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 49);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/packages.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = __webpack_require__(15);

var _promise2 = _interopRequireDefault(_promise);

exports.findPackageSync = findPackageSync;
exports.findPackage = findPackage;
exports.splitPath = splitPath;
exports.pathExists = pathExists;
exports.findPackageManifest = findPackageManifest;
exports.execSync = execSync;

var _path = __webpack_require__(32);

var _fs = __webpack_require__(17);

var _child_process = __webpack_require__(37);

var _findNodeModules = __webpack_require__(38);

var _findNodeModules2 = _interopRequireDefault(_findNodeModules);

var _findupSync = __webpack_require__(39);

var _findupSync2 = _interopRequireDefault(_findupSync);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function findPackageSync(packageName) {
  var cwd = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : process.cwd();
  var searchFor = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'node_modules';

  var moduleDirectories = (0, _findNodeModules2.default)(cwd, { relative: false, searchFor: searchFor });

  var directory = moduleDirectories.find(function (p) {
    var exists = pathExists((0, _path.join)(p, packageName));
    return exists;
  });

  if (!directory) {
    try {
      var resolvedPath = (0, _path.dirname)(/*require.resolve*/(!(function webpackMissingModule() { var e = new Error("Cannot find module \".\""); e.code = 'MODULE_NOT_FOUND'; throw e; }())));
      return resolvedPath;
    } catch (error) {
      //console.log('Error looking up package', packageName, error.message)
    }
  }

  return directory && (0, _path.resolve)((0, _path.join)(directory, packageName));
}

function findPackage(packageName) {
  var searchFor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'node_modules';

  return new _promise2.default(function (resolve, reject) {
    var moduleDirectories = (0, _findNodeModules2.default)(process.cwd(), { searchFor: searchFor, relative: false });

    var directory = moduleDirectories.find(function (p) {
      var exists = pathExists((0, _path.join)(p, packageName));
      return exists;
    });

    if (!directory) {
      try {
        var resolvedPath = (0, _path.dirname)(/*require.resolve*/(!(function webpackMissingModule() { var e = new Error("Cannot find module \".\""); e.code = 'MODULE_NOT_FOUND'; throw e; }())));
        resolve(resolvedPath);
        return;
      } catch (error) {}
    }

    if (!directory) {
      reject(packageName);
    }

    var result = (0, _path.resolve)((0, _path.join)(directory, packageName));

    if (result) {
      resolve(result);
    }
  });
}

function splitPath() {
  var p = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  return (0, _path.resolve)(p).split(sep);
}

function pathExists(fp) {
  var fn = typeof _fs.access === 'function' ? _fs.accessSync : _fs.statSync;

  try {
    fn(fp);
    return true;
  } catch (error) {
    return false;
  }
}

function findPackageManifest() {
  var cwd = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : process.cwd();

  return (0, _findupSync2.default)('package.json', { cwd: cwd });
}

/**
 * Run nodes child_promise exec synchronously and capture the output, trimming any newlines or leading spaces
 * @param  {String} cmd     The command string, exactly the same as child_process.execSync
 * @param  {Object} options =             {} Any arguments for execSync will work here
 * @return {String}         Returns the command output
 */
function execSync(cmd) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return (0, _child_process.execSync)(cmd, options).toString().trim();
}

/***/ },

/***/ 15:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/promise");

/***/ },

/***/ 17:
/***/ function(module, exports) {

module.exports = require("fs");

/***/ },

/***/ 32:
/***/ function(module, exports) {

module.exports = require("path");

/***/ },

/***/ 33:
/***/ function(module, exports) {

function webpackEmptyContext(req) {
	throw new Error("Cannot find module '" + req + "'.");
}
webpackEmptyContext.keys = function() { return []; };
webpackEmptyContext.resolve = webpackEmptyContext;
module.exports = webpackEmptyContext;
webpackEmptyContext.id = 33;


/***/ },

/***/ 37:
/***/ function(module, exports) {

module.exports = require("child_process");

/***/ },

/***/ 38:
/***/ function(module, exports) {

module.exports = require("find-node-modules");

/***/ },

/***/ 39:
/***/ function(module, exports) {

module.exports = require("findup-sync");

/***/ },

/***/ 49:
/***/ function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("./src/packages.js");


/***/ }

/******/ })
});
;