module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.l = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// identity function for calling harmory imports with the correct context
/******/ 	__webpack_require__.i = function(value) { return value; };

/******/ 	// define getter function for harmory exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		Object.defineProperty(exports, name, {
/******/ 			configurable: false,
/******/ 			enumerable: true,
/******/ 			get: getter
/******/ 		});
/******/ 	};

/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};

/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 45);
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/object-hash.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

module.exports = __webpack_require__(13);

/***/ },

/***/ "./src/properties.js":
/***/ function(module, exports, __webpack_require__) {

"use strict";
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hide = exports.collectionMethods = exports.arrayMethods = exports.objectMethods = exports.createEntity = exports.hashObject = exports.lodash = undefined;

var _typeof2 = __webpack_require__(4);

var _typeof3 = _interopRequireDefault(_typeof2);

var _keys = __webpack_require__(0);

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = __webpack_require__(3);

var _extends3 = _interopRequireDefault(_extends2);

var _toConsumableArray2 = __webpack_require__(7);

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _defineProperty = __webpack_require__(2);

var _defineProperty2 = _interopRequireDefault(_defineProperty);

exports.propertyUtils = propertyUtils;
exports.createCollection = createCollection;
exports.mixinPropertyUtils = mixinPropertyUtils;
exports.createInterface = createInterface;
exports.applyInterface = applyInterface;
exports.mixinLodashMethods = mixinLodashMethods;
exports.hideProperties = hideProperties;
exports.hideGetter = hideGetter;
exports.getter = getter;
exports.hideProperty = hideProperty;
exports.lazy = lazy;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var lodash = __webpack_require__(17);
var hashObject = __webpack_require__("./src/object-hash.js");
var pickBy = lodash.pickBy,
    mapValues = lodash.mapValues,
    partial = lodash.partial,
    isFunction = lodash.isFunction,
    isArray = lodash.isArray,
    isObject = lodash.isObject,
    has = lodash.has,
    camelCase = lodash.camelCase,
    cloneDeep = lodash.cloneDeep,
    lowerFirst = lodash.lowerFirst,
    omit = lodash.omit;
var defineProperty = _defineProperty2.default;
exports.lodash = lodash;
exports.hashObject = hashObject;

/**
 * Creates some functions that are useful when trying to decorate objects with hidden properties or getters,
 * or lazy loading properties, etc.  I use this a lot inside of constructor functions for singleton type objects.
 *
 * @param  {Object} target This is the object you intend to be decorating
 * @return {Object}        Returns an object with some wrapper functions around Object.defineProperty
 */

function propertyUtils(target) {
  return {
    lazy: partial(lazy, target),
    hide: partial(hideProperty, target),
    hideProperty: partial(hideProperty, target),
    hideGetter: partial(hideGetter, target),
    hideProperties: partial(hideProperties, target),
    getter: partial(getter, target),
    applyInterface: partial(applyInterface, target)
  };
}

function createCollection() {
  var host = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var items = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  mixinPropertyUtils(host, true, false);

  host.lazy('models', function () {
    return mixinPropertyUtils((isFunction(items) ? items.call(host) : items) || [], true);
  });

  return host;
}

function mixinPropertyUtils(target) {
  var includeLodashMethods = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  var includeChain = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var propUtils = propertyUtils(target);

  mapValues(propUtils, function (fn, name) {
    hideProperty(target, name, fn);
  });

  if (includeLodashMethods) {
    if (isObject(target) && !isArray(target)) {
      objectMethods.forEach(function (name) {
        return hideProperty(target, name, partial(lodash[name], target));
      });
    } else if (isArray(target)) {
      collectionMethods.forEach(function (name) {
        return hideProperty(target, name, partial(lodash[name], target));
      });
      arrayMethods.forEach(function (name) {
        return hideProperty(target, name, partial(lodash[name], target));
      });
    }
  }

  if (includeChain && !has(target, 'chain')) {
    target.hideGetter('chain', function () {
      return lodash.chain(target);
    });
  }

  return target;
}

var transformKey = function transformKey(key) {
  return lowerFirst(camelCase(key.replace(new RegExp('^(get|lazy)', ''), '')));
};

function createInterface() {
  var interfaceMethods = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var _options$insertOption = options.insertOptions,
      insertOptions = _options$insertOption === undefined ? true : _options$insertOption,
      _options$partial = options.partial,
      partial = _options$partial === undefined ? [] : _options$partial,
      _options$right = options.right,
      right = _options$right === undefined ? true : _options$right,
      scope = options.scope,
      _options$defaultOptio = options.defaultOptions,
      defaultOptions = _options$defaultOptio === undefined ? {} : _options$defaultOptio;

  // limit the interface to functions, and unless safe is set to false, non existing properties

  var interFace = mapValues(pickBy(interfaceMethods, isFunction), function (prop, propName) {
    return function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (partial.length > 0 && right === false) {
        args = [].concat((0, _toConsumableArray3.default)(partial), (0, _toConsumableArray3.default)(args));
      }

      if (insertOptions && args.length === 0) {
        args.unshift(defaultOptions);
      }

      if (right === true && partial.length > 0) {
        var _args;

        (_args = args).push.apply(_args, (0, _toConsumableArray3.default)(partial));
      }

      return prop.call.apply(prop, [scope].concat((0, _toConsumableArray3.default)(args)));
    };
  });

  defineProperty(interFace, 'isInterface', {
    enumerable: false,
    value: true,
    configurable: false
  });

  return interFace;
}

function applyInterface(target) {
  var methods = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var _options$scope = options.scope,
      scope = _options$scope === undefined ? target : _options$scope,
      _options$transformKey = options.transformKeys,
      transformKeys = _options$transformKey === undefined ? true : _options$transformKey,
      _options$safe = options.safe,
      safe = _options$safe === undefined ? true : _options$safe,
      _options$hidden = options.hidden,
      hidden = _options$hidden === undefined ? false : _options$hidden,
      _options$configurable = options.configurable,
      configurable = _options$configurable === undefined ? false : _options$configurable;


  var i = methods.isInterface ? methods : createInterface(methods, (0, _extends3.default)({
    scope: scope,
    transformKeys: transformKeys,
    safe: safe,
    hidden: hidden
  }, options));

  mapValues(i, function (method, propName) {
    if (transformKeys && propName.startsWith('get')) {
      (hidden ? hideGetter : getter)(target, transformKey(propName), method.bind(scope));
    } else if (transformKeys && propName.startsWith('lazy')) {
      lazy(target, transformKey(propName), method.bind(scope));
    } else if (propName === 'isInterface') {
      // do nothing
    } else {
      defineProperty(target, propName, {
        configurable: configurable,
        enumerable: !hidden,
        value: method.bind(scope)
      });
    }
  });

  return target;
}

function mixinLodashMethods(target) {
  var l = lodashModules().lodashObject;
  (0, _keys2.default)(l).forEach(function (method) {
    return hideProperty(target, method, partial(l[method], target));
  });
  return target;
}
/**
 * Create a bunch of hidden or non-enumerable properties on an object.
 * Equivalent to calling Object.defineProperty with enumerable set to false.
 *
 * @param  {Object} target     The target object which will receive the properties
 * @param  {Object} properties =             {} a key/value pair of
 * @return {Object}            The target object
 */
function hideProperties(target) {
  var properties = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  (0, _keys2.default)(properties).forEach(function (propertyName) {
    hideGetter(target, propertyName, properties[propertyName]);
  });

  return target;
}

/**
 * Create a hidden getter property on the object.
 *
 * @param  {Object}   target  The target object to define the hidden getter
 * @param  {String}   name    The name of the property
 * @param  {Function} fn      A function to call to return the desired value
 * @param  {Object}   options =             {} Additional options
 * @param  {Object}   options.scope The scope / binding for the function will be called in, defaults to target
 * @param  {Array}    options.args arguments that will be passed to the function

 * @return {Object}          Returns the target object
 */
function hideGetter(target, name, fn) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if (typeof options === 'boolean') {
    options = { configurable: options };
  } else if ((typeof options === 'undefined' ? 'undefined' : (0, _typeof3.default)(options)) === 'object') {
    options = (0, _extends3.default)({
      configurable: true,
      scope: target,
      args: []
    }, options);
  } else {
    options = {};
  }

  if (typeof fn === 'function') {
    fn = partial.apply(undefined, [fn].concat((0, _toConsumableArray3.default)(options.args || [])));
  }

  defineProperty(target, name, (0, _extends3.default)({
    enumerable: false
  }, options, {
    get: function get() {
      return typeof fn === 'function' && options.call !== false ? fn.call(options.scope) : fn;
    }
  }));

  return target;
}

// Creates a getter but makes it enumerable
function getter(target, name, fn) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  return hideGetter(target, name, fn, (0, _extends3.default)({}, options, {
    enumerable: true
  }));
}

function hideProperty(target, name, value) {
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

  if (typeof options === 'boolean') {
    options = { configurable: options };
  } else if ((typeof options === 'undefined' ? 'undefined' : (0, _typeof3.default)(options)) === 'object') {
    options = (0, _extends3.default)({
      configurable: true
    }, options);
  } else {
    options = {};
  }

  defineProperty(target, name, (0, _extends3.default)({}, options, {
    enumerable: false,
    value: value
  }));

  return target;
}

/**
 * Creates a lazy loading property on an object.

 * @param  {Object}   target     The target object to receive the lazy loader
 * @param  {String}   attribute  The property name
 * @param  {Function} fn         The function that will be memoized
 * @param  {[type]}   enumerable =             false Whether to make the property enumerable when it is loaded
 * @return {Object}              Returns the target object
 */
function lazy(target, attribute, fn) {
  var enumerable = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

  defineProperty(target, attribute, {
    configurable: true,
    enumerable: enumerable,
    get: function get() {
      delete target[attribute];

      if (enumerable) {
        return target[attribute] = typeof fn === 'function' ? fn.call(target) : fn;
      } else {
        var value = typeof fn === 'function' ? fn.call(target) : fn;

        defineProperty(target, attribute, {
          enumerable: enumerable,
          configurable: true,
          value: value
        });

        return value;
      }
    }
  });

  return target;
}

var createEntity = exports.createEntity = function createEntity() {
  var object = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var includeChain = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

  return mixinPropertyUtils(cloneDeep(object), true, includeChain);
};

var objectMethods = exports.objectMethods = ["assign", "assignIn", "assignInWith", "assignWith", "at", "create", "defaults", "defaultsDeep", "entries", "entriesIn", "extend", "extendWith", "findKey", "findLastKey", "forIn", "forInRight", "forOwn", "forOwnRight", "functions", "functionsIn", "get", "has", "hasIn", "invert", "invertBy", "invoke", "keys", "keysIn", "mapKeys", "mapValues", "merge", "mergeWith", "omit", "omitBy", "pick", "pickBy", "result", "set", "setWith", "toPairs", "toPairsIn", "transform", "unset", "update", "updateWith", "values", "valuesIn"];

var arrayMethods = exports.arrayMethods = ["chunk", "compact", "concat", "difference", "differenceBy", "differenceWith", "drop", "dropRight", "dropRightWhile", "dropWhile", "fill", "findIndex", "findLastIndex", "first", "flatten", "flattenDeep", "flattenDepth", "fromPairs", "head", "indexOf", "initial", "intersection", "intersectionBy", "intersectionWith", "join", "last", "lastIndexOf", "nth", "pull", "pullAll", "pullAllBy", "pullAllWith", "pullAt", "remove", "reverse", "slice", "sortedIndex", "sortedIndexBy", "sortedIndexOf", "sortedLastIndex", "sortedLastIndexBy", "sortedLastIndexOf", "sortedUniq", "sortedUniqBy", "tail", "take", "takeRight", "takeRightWhile", "takeWhile", "union", "unionBy", "unionWith", "uniq", "uniqBy", "uniqWith", "unzip", "unzipWith", "without", "xor", "xorBy", "xorWith", "zip", "zipObject", "zipObjectDeep", "zipWith"];

var collectionMethods = exports.collectionMethods = ["countBy", "each", "eachRight", "every", "filter", "find", "findLast", "flatMap", "flatMapDeep", "flatMapDepth", "forEach", "forEachRight", "groupBy", "includes", "invokeMap", "keyBy", "map", "orderBy", "partition", "reduce", "reduceRight", "reject", "sample", "sampleSize", "shuffle", "size", "some", "sortBy"];

var hide = exports.hide = hideProperty;

/***/ },

/***/ 0:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/keys");

/***/ },

/***/ 13:
/***/ function(module, exports) {

module.exports = require("object-hash");

/***/ },

/***/ 17:
/***/ function(module, exports) {

module.exports = require("lodash");

/***/ },

/***/ 2:
/***/ function(module, exports) {

module.exports = require("babel-runtime/core-js/object/define-property");

/***/ },

/***/ 3:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/extends");

/***/ },

/***/ 4:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/typeof");

/***/ },

/***/ 45:
/***/ function(module, exports, __webpack_require__) {

module.exports = __webpack_require__("./src/properties.js");


/***/ },

/***/ 7:
/***/ function(module, exports) {

module.exports = require("babel-runtime/helpers/toConsumableArray");

/***/ }

/******/ });